!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!   Subroutine :  c a l c _ t e m p _ m e l t

!   Purpose    :  Computation of the melting temperatures.

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine calc_temp_melt(atm1, atm2)

use sico_variables

implicit none
integer i, j, kc, kt
double precision atm1(0:KCMAX), atm2(0:KTMAX)

!-------- Compute the melting temperatures --------

do i=0, IMAX
do j=0, JMAX

   do kt=0, KTMAX
      temp_t_m(kt,j,i) = -BETA*(H_c(j,i)+H_t(j,i)*atm2(kt))
   end do

   do kc=0, KCMAX
      temp_c_m(kc,j,i) = -atm1(kc)*H_c(j,i)
   end do

end do
end do

return
end
