!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!   Function :  m a s k _ u p d a t e

!   Purpose  :  Update of the topography mask due to the sea level.

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

integer function mask_update(z_sl, i, j)

use sico_variables

implicit none
integer, intent(in) :: i, j
double precision, intent(in) ::  z_sl

double precision :: rho_ratio

rho_ratio = RHO_SW/RHO

!-------- Previously ice-free land point or sea point --------

if ( (maske(j,i) == 1).or.(maske(j,i) == 2) ) then

   if (zb(j,i) > z_sl) then
      mask_update = 1   ! now ice-free land point
      return
   else
      mask_update = 2   ! now sea point
      return
   end if

!-------- Previously glaciated land point or floating-ice point!

else if ( (maske(j,i) == 0).or.(maske(j,i) == 3) ) then

   if (zb(j,i) > z_sl) then
      mask_update = 0   ! now glaciated land point
      return
   else
      if ( zs(j,i) < (zb(j,i)+rho_ratio*(z_sl-zb(j,i))) &
         ) then
#if MARGIN==1
         mask_update = 2     ! ice becomes floating, therefore
                             ! now sea point (ice cut off)
#elif MARGIN>=2
         mask_update = 3     ! now floating ice
#endif
         return
      else                   ! now grounded ice
         mask_update = 0
         return
      end if

   end if

end if

end function mask_update
