!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!   Subroutine :  o u t p u t 3

!   Purpose    :  Writing of time-series data of the ice-thickness
!                 field.

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine output3(time, delta_ts, glac_index, z_sl)

use sico_variables

implicit none
integer i, j
double precision time, delta_ts, glac_index, z_sl
double precision time_val, delta_ts_val, glac_index_val, z_sl_val
double precision H_val(0:JMAX,0:IMAX)

!-------- Conversion --------

time_val       = time *0.001d0/YEAR_SEC   ! s --> kyr
delta_ts_val   = delta_ts               ! deg C
glac_index_val = glac_index
z_sl_val       = z_sl                   ! m

do i=0, IMAX
do j=0, JMAX
   H_val(j,i) = (H_c(j,i)+H_t(j,i)) *0.001d0   ! m --> km
end do
end do

!-------- Write data on time-series file --------

if (forcing_flag == 1) then
   write(13,1011) time_val, delta_ts_val, z_sl_val
else if (forcing_flag == 2) then
   write(13,1011) time_val, glac_index_val, z_sl_val
end if

do j=JMAX, 0, -1
   write(13,1012) (H_val(j,i), i=0,IMAX)
end do

 1011 format(/,1pe13.6,2(1pe13.4),/)
 1012 format(IMAX(f7.3),f7.3)

return
end
