!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!   Subroutine :  r e a d _ k e i

!   Purpose    :  Reading of tabulated kei function.

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine read_kei

use sico_variables

implicit none

integer :: n, n_data_kei_max
integer :: ios
double precision :: r_val, d_dummy
character :: ch_dummy

n_data_kei_max = 10000

kei = 0.0d0

!-------- Reading of tabulated values --------

open(11, iostat=ios, &
     file=INPATH//'/general/kei.dat', &
     status='old')
if (ios /= 0) stop ' Error when opening the kei file!'

read(11,'(a)') ch_dummy
read(11,'(15x,f5.0)') kei_r_max
read(11,'(15x,f5.0)') kei_r_incr
read(11,'(a)') ch_dummy

n_data_kei = nint(kei_r_max/kei_r_incr)

if (n_data_kei > n_data_kei_max) stop ' Array kei too small!'

read(11,'(a)') ch_dummy
read(11,'(a)') ch_dummy
read(11,'(a)') ch_dummy

do n=-n_data_kei, n_data_kei
   read(11,*) d_dummy, kei(n)
end do

close(11, status='keep')

end subroutine read_kei
