!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

!   Subroutine :  p h y s _ p a r a

!   Purpose    :  Reading of physical parameters for SICOPOLIS.

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine phys_para

use sico_variables

implicit none
integer, parameter :: n_unit=31
integer :: ios
integer :: n

#if (FLOW_LAW==1)
open(n_unit, iostat=ios, &
     file=INPATH//'/nmars/phys_para_nmars_1.dat', &
     status='old')
#elif (FLOW_LAW==2)
open(n_unit, iostat=ios, &
     file=INPATH//'/nmars/phys_para_nmars_2.dat', &
     status='old')
#elif (FLOW_LAW==3)
open(n_unit, iostat=ios, &
     file=INPATH//'/nmars/phys_para_nmars_3.dat', &
     status='old')
#else
  stop 'Wrong value for parameter FLOW_LAW!'
#endif

if (ios.ne.0) stop ' Error when opening the phys_para file!'

call read_phys_para_value(RHO_I, n_unit)
call read_phys_para_value(RHO_W, n_unit)
call read_phys_para_value(RHO_SW, n_unit)
call read_phys_para_value(L, n_unit)
call read_phys_para_value(G, n_unit)
call read_phys_para_value(NUE, n_unit)
call read_phys_para_value(BETA, n_unit)
call read_phys_para_value(OMEGA_MAX, n_unit)
call read_phys_para_value(RHO_C, n_unit)
call read_phys_para_value(KAPPA_C, n_unit)
call read_phys_para_value(C_C, n_unit)
call read_phys_para_value(H_R, n_unit)
call read_phys_para_value(RHO_C_R, n_unit)
call read_phys_para_value(KAPPA_R, n_unit)
call read_phys_para_value(FLEX_RIG_L, n_unit)
call read_phys_para_value(RHO_A, n_unit)
call read_phys_para_value(TIME_LAG, n_unit)
call read_phys_para_value(R_T, n_unit)
call read_phys_para_value(SIGMA_RES, n_unit)

call read_phys_para_value(R, n_unit)
call read_phys_para_value(PHI0, n_unit)
call read_phys_para_value(LAMBDA0, n_unit)

do n=10, -190, -1
   call read_phys_para_value(RF(n), n_unit)
end do

do n=10, -190, -1
   call read_phys_para_value(KAPPA(n), n_unit)
end do

do n=10, -190, -1
   call read_phys_para_value(C(n), n_unit)
end do

close(n_unit, status='keep')

end subroutine phys_para
